export type HttpRequestInit<TConfig = {}> = RequestInit & {
    config?: TConfig;
    data?: object | null;
};
export type HttpHandler<T = Promise<object>, TConfig = {}> = (req: RequestInfo, init: HttpRequestInit<TConfig>) => T;
export interface Interceptor<TConfig, TRes, TOut> {
    init?: (config: TConfig) => void;
    preRequest?: (request: Request, config: TConfig) => Request;
    postRequest?: (response: TRes, config: TConfig) => TOut;
}
export type InterceptorApplier<TConfig, TIn, TOut> = (parent: HttpHandler<TIn>, config?: Partial<TConfig>) => HttpHandler<TOut, TConfig>;
export interface HttpClientWrapper<TIn, PConfig> {
    wrap<TConfig, TOut>(interceptor: InterceptorApplier<TConfig, TIn, TOut>, config?: Partial<TConfig>): HttpClient<TOut, PConfig | TConfig>;
}
export type HttpClient<T, TConfig> = ((req: RequestInfo, init?: HttpRequestInit<TConfig>) => T) & HttpClientWrapper<T, TConfig>;
export declare function interceptor<TConfig = {}, TIn = Promise<Response>, TOut = TIn>(handlers: {
    init?: (config: TConfig) => TConfig;
    preRequest?: (req: Request, config: TConfig, init?: HttpRequestInit<TConfig>) => Request;
    postRequest?: (res: TIn, config: TConfig) => TOut;
    defaultConfig?: TConfig;
}): InterceptorApplier<TConfig, TIn, TOut>;
export declare function http<T = Promise<Response>, C = {}>(parentClient?: HttpHandler<T, C>): HttpClient<T, C>;
export declare namespace http {
    var _a: () => HttpClient<Promise<any>, {} | {
        appendContentType: boolean;
    } | {
        errorCode: number;
    }>;
    export { _a as default };
}
export declare const httpBodySerialize: InterceptorApplier<{
    appendContentType: boolean;
}, Promise<Response>, Promise<Response>>;
export declare const httpJsonParser: InterceptorApplier<{}, Promise<Response>, Promise<any>>;
export declare const httpErrorCode: InterceptorApplier<{
    errorCode: number;
}, Promise<Response>, Promise<Response>>;
